//+------------------------------------------------------------------+
//|                   RopeExtended_High_StochasticMulti_mj_vx.xx.mq4 |
//|                      Copyright  2010,                       mj  |
//|                                       http://www.noweb.net/      |
//+------------------------------------------------------------------+
#property copyright "Copyright  mj"
#property link      "http://www.noweb.net/"

#define INDICATOR_NAME		"RopeExtended_High_StochasticMulti_mj"
#define INDICATOR_VERSION	"_v1.00"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 Red // Main
#property indicator_width1 2
#property  indicator_style1  STYLE_SOLID
#property indicator_color2 EMPTY // Signal
#property indicator_width2 1
#property  indicator_style2  STYLE_DOT	


//---- input parameters
extern string Note1="This can merge a couple of";
extern string Note2="Stoch into one output.";
extern string Note3="Each StochWeight/AllWeight";
//---- DisplayLastBar
extern string  INFO="Current Bar Display";
extern bool    DisplayLastBar=true;

//---- STOCH 0
extern string  INFO0="--- 0 ---";
extern int     KPeriod0=18;
extern int     DPeriod0=1;
extern int     Slowing0=1;
extern int     MaMethod0=0; // SMA 0, EMA 1, SMMA 2, LWMA 3
extern int     PriceField0=1; // Low/High 0, Close/Close 1
extern double  Weight0=1.0;

//---- STOCH 1
extern string  INFO1="--- 1 ---";
extern int     KPeriod1=19;
extern int     DPeriod1=1;
extern int     Slowing1=1;
extern int     MaMethod1=0; // SMA 1, EMA 1, SMMA 2, LWMA 3
extern int     PriceField1=1; // Low/High 0, Close/Close 1
extern double  Weight1=1.0;

//---- STOCH 2
extern string  INFO2="--- 2 ---";
extern int     KPeriod2=20;
extern int     DPeriod2=1;
extern int     Slowing2=1;
extern int     MaMethod2=0; // SMA 2, EMA 1, SMMA 2, LWMA 3
extern int     PriceField2=1; // Low/High 0, Close/Close 1
extern double  Weight2=1.0;

//---- STOCH 3
extern string  INFO3="--- 3 ---";
extern int     KPeriod3=21;
extern int     DPeriod3=1;
extern int     Slowing3=1;
extern int     MaMethod3=0; // SMA 3, EMA 1, SMMA 2, LWMA 3
extern int     PriceField3=1; // Low/High 0, Close/Close 1
extern double  Weight3=1.0;

//---- STOCH 4
extern string  INFO4="--- 4 ---";
extern int     KPeriod4=22;
extern int     DPeriod4=1;
extern int     Slowing4=1;
extern int     MaMethod4=0; // SMA 4, EMA 1, SMMA 2, LWMA 3
extern int     PriceField4=1; // Low/High 0, Close/Close 1
extern double  Weight4=1.0;

//---- STOCH 5
extern string  INFO5="--- 5 ---";
extern int     KPeriod5=23;
extern int     DPeriod5=1;
extern int     Slowing5=1;
extern int     MaMethod5=0; // SMA 5, EMA 1, SMMA 2, LWMA 3
extern int     PriceField5=1; // Low/High 0, Close/Close 1
extern double  Weight5=1.0;

//---- STOCH 6
extern string  INFO6="--- 6 ---";
extern int     KPeriod6=24;
extern int     DPeriod6=1;
extern int     Slowing6=1;
extern int     MaMethod6=0; // SMA 6, EMA 1, SMMA 2, LWMA 3
extern int     PriceField6=1; // Low/High 0, Close/Close 1
extern double  Weight6=1.0;

//---- STOCH 7
extern string  INFO7="--- 7 ---";
extern int     KPeriod7=25;
extern int     DPeriod7=1;
extern int     Slowing7=1;
extern int     MaMethod7=0; // SMA 7, EMA 1, SMMA 2, LWMA 3
extern int     PriceField7=1; // Low/High 0, Close/Close 1
extern double  Weight7=1.0;


//---- STOCH 8
extern string  INFO8="--- 8 ---";
extern int     KPeriod8=26;
extern int     DPeriod8=1;
extern int     Slowing8=1;
extern int     MaMethod8=0; // SMA 8, EMA 1, SMMA 2, LWMA 3
extern int     PriceField8=1; // Low/High 0, Close/Close 1
extern double  Weight8=1.0;


//---- STOCH 9
extern string  INFO9="--- 9 ---";
extern int     KPeriod9=27;
extern int     DPeriod9=1;
extern int     Slowing9=1;
extern int     MaMethod9=0; // SMA 9, EMA 1, SMMA 2, LWMA 3
extern int     PriceField9=1; // Low/High 0, Close/Close 1
extern double  Weight9=1.0;


//---- STOCH 10
extern string  INFO10="--- 10 ---";
extern int     KPeriod10=28;
extern int     DPeriod10=1;
extern int     Slowing10=1;
extern int     MaMethod10=0; // SMA 10, EMA 1, SMMA 2, LWMA 3
extern int     PriceField10=1; // Low/High 0, Close/Close 1
extern double  Weight10=1.0;



//---- STOCH 11
extern string  INFO11="--- 11 ---";
extern int     KPeriod11=29;
extern int     DPeriod11=1;
extern int     Slowing11=1;
extern int     MaMethod11=0; // SMA 11, EMA 1, SMMA 2, LWMA 3
extern int     PriceField11=1; // Low/High 0, Close/Close 1
extern double  Weight11=1.0;

//---- STOCH 12
extern string  INFO12="--- 12 ---";
extern int     KPeriod12=30;
extern int     DPeriod12=1;
extern int     Slowing12=1;
extern int     MaMethod12=0; // SMA 12, EMA 1, SMMA 2, LWMA 3
extern int     PriceField12=1; // Low/High 0, Close/Close 1
extern double  Weight12=1.0;

//---- STOCH 13
extern string  INFO13="--- 13 ---";
extern int     KPeriod13=31;
extern int     DPeriod13=1;
extern int     Slowing13=1;
extern int     MaMethod13=0; // SMA 13, EMA 1, SMMA 2, LWMA 3
extern int     PriceField13=1; // Low/High 0, Close/Close 1
extern double  Weight13=1.0;


//---- STOCH 14
extern string  INFO14="--- 14 ---";
extern int     KPeriod14=32;
extern int     DPeriod14=1;
extern int     Slowing14=1;
extern int     MaMethod14=0; // SMA 14, EMA 1, SMMA 2, LWMA 3
extern int     PriceField14=1; // Low/High 0, Close/Close 1
extern double  Weight14=1.0;





//---- buffers
double MainBuffer[];
double SignalBuffer[];

double TempBuffer[];





//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   string short_name;
   
//---- indicator lines
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, MainBuffer);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1, SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name=INDICATOR_NAME  + INDICATOR_VERSION;
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name + " - Main %K");
   SetIndexLabel(1,"Signal %D");
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Stochastic oscillator                                            |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
  {

   int limit, i, dlb;
   double AllStochMain,AllStochSignal;
   double AllWeight= Weight0+Weight1+Weight2+Weight3+Weight4+Weight5+Weight6+Weight7+Weight8+Weight9+Weight10+Weight11+Weight12+Weight13+Weight14;

         
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;

   //
   //
   //
   //
   //
   
   // Check NoLastBar;
   if (DisplayLastBar) dlb=0;
   else dlb=1;
   
   for(i=dlb; i<limit; i++)
   {
      AllStochMain=0;
      AllStochSignal=0;
      
       if (Weight0 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod0, DPeriod0, Slowing0,MaMethod0, PriceField0, MODE_MAIN, i)) * (Weight0/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod0, DPeriod0, Slowing0,MaMethod0, PriceField0, MODE_SIGNAL, i)) * (Weight0/AllWeight); 
         }       
           
 
       if (Weight1 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod1, DPeriod1, Slowing1,MaMethod1, PriceField1, MODE_MAIN, i)) * (Weight1/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod1, DPeriod1, Slowing1,MaMethod1, PriceField1, MODE_SIGNAL, i)) * (Weight1/AllWeight); 
         }   
         
 
       if (Weight2 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod2, DPeriod2, Slowing2,MaMethod2, PriceField2, MODE_MAIN, i)) * (Weight2/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod2, DPeriod2, Slowing2,MaMethod2, PriceField2, MODE_SIGNAL, i)) * (Weight2/AllWeight); 
         }   
         
         
 
       if (Weight3 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod3, DPeriod3, Slowing3,MaMethod3, PriceField3, MODE_MAIN, i)) * (Weight3/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod3, DPeriod3, Slowing3,MaMethod3, PriceField3, MODE_SIGNAL, i)) * (Weight3/AllWeight); 
         }   
         
         
 
       if (Weight4 > 0) 
         {
            AllStochMain =AllStochMain + (iStochastic(NULL, 0, KPeriod4, DPeriod4, Slowing4,MaMethod4, PriceField4, MODE_MAIN, i)) * (Weight4/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod4, DPeriod4, Slowing4,MaMethod4, PriceField4, MODE_SIGNAL, i)) * (Weight4/AllWeight); 
         }   
         
 
       if (Weight5 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod5, DPeriod5, Slowing5,MaMethod5, PriceField5, MODE_MAIN, i)) * (Weight5/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod5, DPeriod5, Slowing5,MaMethod5, PriceField5, MODE_SIGNAL, i)) * (Weight5/AllWeight); 
         }   
         
       if (Weight6 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod6, DPeriod6, Slowing6,MaMethod6, PriceField6, MODE_MAIN, i)) * (Weight6/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod6, DPeriod6, Slowing6,MaMethod6, PriceField6, MODE_SIGNAL, i)) * (Weight6/AllWeight); 
         }   
         
       if (Weight7 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod7, DPeriod7, Slowing7,MaMethod7, PriceField7, MODE_MAIN, i)) * (Weight7/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod7, DPeriod7, Slowing7,MaMethod7, PriceField7, MODE_SIGNAL, i)) * (Weight7/AllWeight); 
         }   
                  
       if (Weight8 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod8, DPeriod8, Slowing8,MaMethod8, PriceField8, MODE_MAIN, i)) * (Weight8/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod8, DPeriod8, Slowing8,MaMethod8, PriceField8, MODE_SIGNAL, i)) * (Weight8/AllWeight); 
         }   
         
       if (Weight9 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod9, DPeriod9, Slowing9,MaMethod9, PriceField9, MODE_MAIN, i)) * (Weight9/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod9, DPeriod9, Slowing9,MaMethod9, PriceField9, MODE_SIGNAL, i)) * (Weight9/AllWeight); 
         }   
         
       if (Weight10 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod10, DPeriod10, Slowing10,MaMethod10, PriceField10, MODE_MAIN, i)) * (Weight10/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod10, DPeriod10, Slowing10,MaMethod10, PriceField10, MODE_SIGNAL, i)) * (Weight10/AllWeight); 
         }   
      
       if (Weight10 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod10, DPeriod10, Slowing10,MaMethod10, PriceField10, MODE_MAIN, i)) * (Weight10/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod10, DPeriod10, Slowing10,MaMethod10, PriceField10, MODE_SIGNAL, i)) * (Weight10/AllWeight); 
         }   
         
       if (Weight12 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod12, DPeriod12, Slowing12,MaMethod12, PriceField12, MODE_MAIN, i)) * (Weight12/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod12, DPeriod12, Slowing12,MaMethod12, PriceField12, MODE_SIGNAL, i)) * (Weight12/AllWeight); 
         }
         
       if (Weight13 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod13, DPeriod13, Slowing13,MaMethod13, PriceField13, MODE_MAIN, i)) * (Weight13/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod13, DPeriod13, Slowing13,MaMethod13, PriceField13, MODE_SIGNAL, i)) * (Weight13/AllWeight); 
         }         
         
       if (Weight14 > 0) 
         {
            AllStochMain = AllStochMain + (iStochastic(NULL, 0, KPeriod14, DPeriod14, Slowing14,MaMethod14, PriceField14, MODE_MAIN, i)) * (Weight14/AllWeight);
            AllStochSignal = AllStochSignal + (iStochastic(NULL, 0, KPeriod14, DPeriod14, Slowing14,MaMethod14, PriceField14, MODE_SIGNAL, i)) * (Weight14/AllWeight); 
         }         
         
                
                                                                                                          

      MainBuffer[i] = AllStochMain;
      
      SignalBuffer[i] = AllStochSignal;     
   }
     
//---- done
   return(0);
}


//+------------------------------------------------------------------+